#include "ADuc7039.h"   
                      

///////////////////////////////////////////////////////
// Filename:   	main.c
// Author:     	ADI
// Date:    	19th 19/01/2009
// Description: This program will BLINK the GPIO's and LED on the 
//				ADuc7039  Evaluation Board. it also provides code 
//   			that set's up the ADC for sampling 
//				VBAT / VTEMP / IADC channel. This dat can be viewed 
//				in the WATCH windows.
//				
//
///////////////////////////////////////////////////////


// Constants
#define WAKEUP_TIMER_BIT         0x0010   
#define WATCHDOG_TIMER_BIT       0x0010                 
#define GPxDAT_DIR_VAL           0xFF000000
#define KERNEL_DL_KEY_ADDR       0x01FC


void  InterruptIRQHndlr   (void);
void delay(int);

static unsigned long ulDir    = 0x1;
static unsigned long ulLoop   = 0x0;

	unsigned int VBAT_data=0;
	unsigned int VTEMP_data=0;
	unsigned int IADC_data=0;

	unsigned char adc_status=0;

 
// Function    : MyIRQHandler
// Author      : ADI
// Description : Advance leds based on timer interrupt
// Revision    : 09.09.2005 - Initial
void  InterruptIRQHndlr   (void)
{
   if ((IRQSTA & WAKEUP_TIMER_BIT) != 0)      // Timer2 IRQ?
      {
      if (ulDir)
         {
         GPDAT = GPxDAT_DIR_VAL | (0x00010000 << ulLoop);
         }
      else
         {
         GPDAT = GPxDAT_DIR_VAL | (0x00100000 >> ulLoop);
         }

      ulLoop++;

      if (ulLoop == 0x6)
         {
         ulLoop = 0x0;
         if (ulDir)
            ulDir = 0x0;
         else
            ulDir = 0x1;
         }
      T2CLRI = 0x0; // Clear the interrupt
      }
}

// Function    : ConfigureTimer2
// Description : ConfigureTimer2
// Revision    : 21.06.2005 - Initial
void ConfigureTimer2(void)
{
   // Initialise
   IRQCLR      = WAKEUP_TIMER_BIT;  // Timer2 IRQ
   IRQ         = InterruptIRQHndlr; // Specify Interrupt Service Rountine
   T2LD        = 0x1000;      
   T2CON       = 0x2C0;                                 
   IRQEN       = WAKEUP_TIMER_BIT;    // Timer2 IRQ
}

extern const unsigned char ucConstRandData[];

void ADC_VBAT_SetUp(void)
{
	unsigned long adc_status=0;

	 ADCMSKI = 0x00;			// interupt Mask  - No need to do this but ...
	 ADCMDE = 0x001;				// 0000 0001    NO int, Normal mode, Cont conv.
	 ADC1CON = 0x8210;	    // ADC enabld, uA OFF, 2's Compl, VBAT, int Ref
	 ADC0CON = 0x8200;						// 1000 0000 0000 0000  	
	 ADCFLT	= 0xC07F;		// ChopEn, Run Av, AF n/A , SINC mod, DEC Fac 50Hz notch
	 						//  1100 0000 0111 1111
	 ADCCFG = 0xC0;			// No GND SW, No Acc, NO Com, No Counter
	 						// 0000 0000
 	 adc_status = ADCSTA;	// check status for any issues:
	 while((adc_status & 0x02) == 1)	// Wait for Voltage Conv Ready
	 	 adc_status = ADCSTA;	 // check status for any issues:

	  VBAT_data = ADC1DAT;
 }


void delay (int length)
{
	while (length >=0)
    	length--;
}
// Function    : main
// Author      : ADI
// Description : main
// Revision    : 28.07.2008 - Initial

int main(void)
{  

 		   					// Blink Leds on ADuc7039 eval board
   GPCON = 0x0;
   GPDAT = GPxDAT_DIR_VAL;
    						// Toggle the leds based on timer interrupt
//   ConfigureTimer2();

  		// Configure tha ADC
	ADC_VBAT_SetUp();


   while (1)
   	{
							// Reading  VBAT
// 	 ADC1CON = 0x8000;	    // ADC enabld, uA OFF, 2's Compl, VBAT, int Ref
 	 ADC1CON = 0x8210;	    
	 // 10000 0010 0001 0000  	ADC enabld, uA OFF, uniPolar, VBAT, REG_AVDD

    adc_status = ADCSTA;	// check status for any issues:
	 while((adc_status & 0x02) == 1)	// Wait for Voltage Conv Ready
	 	 adc_status = ADCSTA;	 // check status for any issues:
	 VBAT_data = ADC1DAT;	// check Data read - dummy read for checking

							// Switch to VTEMP
// 	 ADC1CON = 0x8040;	    // ADC enabld, uA OFF, 2's Compl, VBAT, int Ref
							// 1000 0000 0100 0000

 	 ADC1CON = 0x8200;	    
	 // 10000 0010 0000 0000  	ADC enabld, uA OFF, uniPolar, VBAT, int Ref

     adc_status = ADCSTA;	// check status for any issues:
	 while((adc_status & 0x04) == 1)	// Wait for Temperature Conversion Conv Ready
	 	 adc_status = ADCSTA;	 // check status for any issues:
	 VTEMP_data = ADC1DAT;	//  Data read  

	 						// Switch to I-ADC
 	 ADC0CON = 0x8002;	    // ADC enabld, uA OFF, 2's Compl, VBAT, int Ref
							// 1000 0000 0000 0010
	 IADC_data = ADC0DAT;	//  Dummy Data read  
     adc_status = ADCSTA;	// check status for any issues:
//	 while((adc_status & 0x01) == 1)	// Wait for Temperature Conversion Conv Ready
//	 	 adc_status = ADCSTA;	 // check status for any issues:
 	 IADC_data = ADC0DAT;	//  Data read  
 
 	} ; // loop

}





